#include <stdio.h>
#include <string.h>
#include <math.h>

long i;

FILE* infile;
FILE* outfile;
FILE* outfile2;


char ChunkID[5],Format[5],Subchunk1ID[5],Subchunk2ID[5];
char infilename[256];
char outfilename[256];
char vszfilename[256];
char stylefilename[256];
char outfile2name[256];
char histfilename[256];
char crestfilename[256];
char appdirname[256];

unsigned char datablock[115201];
double left[19201],right[19201];
long h_left[81], h_right[81], hc_left[40], hc_right[40];
long hcount;

char c1,c2;

long ChunkSize,Subchunk1Size,AudioFormat;
long NumChannels,SampleRate,ByteRate,BlockAlign;
long BitsPerSample,BytesPerSample;

unsigned long Subchunk2Size;

long block_size,offset,size_found,block_number,block_count;

long i,ok,l_int,r_int,icut,icut2,icut24,icut224;
long li,ri,slat,oko,pairs_per_block,hcut;

double duration,dt,dt_ms,t_ms,duration_ms,scale16,scale24;
double time_offset;

double left_peak,right_peak,left_rms,right_rms,left_crest,right_crest;

void get4(char*);
long get4int(void);
long get3int(void);
long get2int(void);
long read_header(void);

void make_vsz_file(void);
void make_vsz_file2(void);

long load_block(void);
void convert_block16(void);
void convert_block24(void);
void process_block(void);
double maggie(double);
double dB(double);

void zero_histograms(void);
void update_histograms(void);
void report_histograms(void);

int main(int argc,char*argv[])
{
  icut=32768; icut2=2*icut;
  icut24=icut*256; icut224=2*icut24;
  scale16=1.0/(double)icut;
  scale24=1.0/(double)icut24;
  hcut=80;
  
  zero_histograms();
  
  printf("WAVStats v 1.01 (14 May 2010)\n");
  printf("Reads an LPCM Wave file and generates a simple\n");
  printf("statistical examination of the sound levels.\n\n");
  
  i=argc;
  printf("Number of arguments given = %ld\n\n",i);

  if(i>0) printf("Application at  = %s\n",argv[0]);
  
  sprintf(outfilename,"%s",argv[0]);
  
  slat=(long)strrchr(outfilename,'/')-(long)outfilename;
  outfilename[slat]=(char)0;
  sprintf(appdirname,"%s",outfilename);

  sprintf(outfile2name,"%s/histograms.csv\0",appdirname);
  sprintf(outfilename,"%s/powers.csv\0",appdirname);
  
  
  printf("outfile name %s\n",outfilename);
  
  if(i>1)
  {
    printf("Input File at = %s\n",argv[1]);
    sprintf(infilename,"%s\0",argv[1]);
    infile=fopen(argv[1],"rd");
    i=read_header();
    printf("%ld\n",i);
    duration=(double)Subchunk2Size/(double)ByteRate;
    printf("Duration = %6.2lf sec\n",duration);
    dt=1000.0/(double)SampleRate; t_ms=0.0;
    
    block_size=(long)((double)ByteRate*0.1);
    
    printf("Block size [bytes per 0.1 sec] = %ld\n",block_size);
    
    pairs_per_block=(long)((double)SampleRate*0.1);
    
    printf("Samples per channel per 0.1 sec = %ld\n",pairs_per_block);
    
    block_count=0;
    
    outfile=fopen(outfilename,"wt");
    fprintf(outfile,"\"Time\",\"Left peak\",\"Right peak\",\"Left crest\",\"Right crest\",\n");
    
    if(BytesPerSample==3)
    {
      printf("24 bit conversions\n");
      do
      {
        size_found=load_block();
        if (size_found==block_size)
        {
           convert_block24();
           process_block();
           fprintf(outfile,"%5.1lf, %6.2lf, %6.2lf,",0.1*(double)block_count,left_peak,right_peak);
           fprintf(outfile," %6.2lf, %6.2lf,\n",left_crest,right_crest);
        }
        
        block_count++;
      } while (size_found==block_size);
    }
    
    if(BytesPerSample==2)
    {
      printf("16 bit conversions\n");
      do
      {
        size_found=load_block();
        if (size_found==block_size)
        {
           convert_block16();
           process_block();
           fprintf(outfile,"%5.1lf, %6.2lf, %6.2lf,",0.1*(double)block_count,left_peak,right_peak);
           fprintf(outfile," %6.2lf, %6.2lf,\n",left_crest,right_crest);
        }
        
        block_count++;
      } while (size_found==block_size);
    }
    
    fclose(infile);
    fclose(outfile);
    make_vsz_file();
    report_histograms();
    make_vsz_file2();
    
    

  }
  else
  {
    printf("No input file!\n");
    printf("Drag a WAV file to the ReadWAVHeader application icon\n");
    printf("to see the results\n");
  }
       
  printf("Done!\n");
  return 0;
}

void zero_histograms(void)
{
  long ih;
  ih=0;
  do
  {
    h_left[ih]=0; h_right[ih]=0;
    ih++;
  } while (ih<=80);
  ih=0;
  do
  {
    hc_left[ih]=0; hc_right[ih];
    ih++;
  } while (ih<40);
  hcount=0;
}

void update_histograms(void)
{
  long iu;
  iu=(long)left_peak;
  iu=-iu;
  if(iu>=0)
  {
    if(iu<hcut)
    {
      h_left[iu]=h_left[iu]+1;
    }
  }
  
  iu=(long)right_peak;
  iu=-iu;
  if(iu>=0)
  {
    if(iu<hcut)
    {
      h_right[iu]=h_right[iu]+1;
    }
  }
  
  iu=(long)left_crest;
  if(iu>=0)
  {
    if(iu<40)
    {
      hc_left[iu]=hc_left[iu]+1;
    }
  }
  
  iu=(long)right_crest;
  if(iu>=0)
  {
    if(iu<40)
    {
      hc_right[iu]=hc_right[iu]+1;
    }
  }
  
  hcount++;
}

void report_histograms(void)
{
  long ih;
  double hiscale,hl,hr;
  sprintf(outfilename,"%s/histogram_power.csv\0",appdirname);
  printf("Power histogram save into file =\n    %s\n\n",outfilename);
  sprintf(histfilename,"%s",outfilename);
  hiscale=(double)hcount;
  hiscale=100.0/hiscale;
  
  outfile=fopen(outfilename,"wt");
  
  fprintf(outfile,"\"power dB\",\"left percent\",\"right percent\",\n");
  
  ih=0;
  do
  {
    hl=(double)h_left[ih]; hr=(double)h_right[ih];
    hl=hiscale*hl; hr=hiscale*hr;
    
    fprintf(outfile,"%7.1lf, %7.2lf, %7.2lf,\n",(double)(-ih),hl,hr);
    ih++;
  
  } while (ih<=hcut);
  fclose(outfile);
  
  sprintf(outfilename,"%s/histogram_crest.csv\0",appdirname);
  printf("Crest factor histogram saved into =\n   %s\n\n",outfilename);
  sprintf(crestfilename,"%s",outfilename);
  outfile=fopen(outfilename,"wt");
  
  fprintf(outfile,"\"power dB\",\"left percent\",\"right percent\",\n");
  
  ih=0;
  do
  {
    hl=(double)hc_left[ih]; hr=(double)hc_right[ih];
    hl=hiscale*hl; hr=hiscale*hr;
    
    fprintf(outfile,"%7.1lf, %7.2lf, %7.2lf,\n",(double)(ih),hl,hr);
    ih++;
  
  } while(ih<40);
  
  fclose(outfile);
  
}

long load_block(void)
{
  long result;
  result= (long)fread(datablock,sizeof(unsigned char),block_size,infile);
  return result;
}

double maggie(double lin)
{
  double answer;
  if (lin>0.0)
  {
    answer=lin;
  }
  else
  {
    answer=-lin;
  }
  return answer;
}

double dB(double xin)
{
  double answer;
  answer=log10(xin);
  answer=20.0*answer;
  return answer;
}

void process_block(void)
{
  long ii;
  double ln,rn,lp,rp,lrms,rrms;
  lp=0.0; rp=0.0; lrms=0.0; rrms=0.0; ii=0;
  do
  {
    ln=left[ii]; rn=right[ii];
    if(maggie(ln)>lp) lp=maggie(ln);
    if(maggie(rn)>rp) rp=maggie(rn);
    
    lrms+=ln*ln; rrms+=rn*rn;
    
    ii++;
  } while(ii<pairs_per_block);
  
  lrms=lrms/(double)pairs_per_block;
  rrms=rrms/(double)pairs_per_block;
  
  lrms=sqrt(lrms); rrms=sqrt(rrms);
  
  left_rms=dB(lrms);
  right_rms=dB(rrms);
  
  left_peak=dB(lp);
  right_peak=dB(rp);
  
  left_crest=left_peak-left_rms;
  right_crest=right_peak-right_rms;
  
  update_histograms();
}

void convert_block16(void)
{
  /* This procedure converts the values in the data block
     into integers, ready for examination. */
  
  long io,ii,lt,rt;
  ii=0; io=0;
  
  do
  {
    lt=  256*(long)datablock[ii+1] + (long)datablock[ii];
    ii+=2;
    
    
    if(NumChannels==2)
    {
      rt= 256*(long)datablock[ii+1] + (long)datablock[ii];
      ii+=2;
    }
    else
    {
      rt=lt;
    }
    if (lt>=icut) lt-=icut2;
    if (rt>=icut) rt-=icut2;
    left[io]=scale16*(double)lt;
    right[io]=scale16*(double)rt;
    io++;
  } while (io<pairs_per_block);
}

void convert_block24(void)
{
  /* This procedure converts the values in the data block
     into integers, ready for examination. */
  
  long io,ii,lt,rt;
  ii=0; io=0;
  
  do
  {
    lt= 65536*(long)datablock[ii+2] + 256*(long)datablock[ii+1] + (long)datablock[ii];
    ii+=3;
    
    
    if(NumChannels==2)
    {
      rt= 65536*(long)datablock[ii+2] +256*(long)datablock[ii+1] + (long)datablock[ii];
      ii+=3;
    }
    else
    {
      rt=lt;
    }
    if (lt>=icut24) lt-=icut224;
    if (rt>=icut24) rt-=icut224;
    left[io]=scale24*(double)lt;
    right[io]=scale24*(double)rt;
    io++;
  } while (io<pairs_per_block);
}


void make_vsz_file(void)
{
  int vszcount,vszcheck;
  char vszchar;
  sprintf(vszfilename,"%s/import_powers.vsz\0",appdirname);
  sprintf(stylefilename,"%s/style_powers.vsz\0",appdirname);
  printf("\nMaking Veusz import file =\n   %s\n",vszfilename);
  printf(" using style from = %s\n\n",stylefilename);
  outfile=fopen(vszfilename,"wt");
  
  fprintf(outfile,"# This file can be used to load output from\n# WAVReader into Veusz\n");
  fprintf(outfile,"# Data from WAV file  %s\n\n",infilename);
  fprintf(outfile,"ImportFileCSV('%s', linked=True)\n\n",outfilename);
  
  infile=fopen(stylefilename,"rt");
  vszcount=0;
  do
  {
    vszcheck=(int)fscanf(infile,"%c",&vszchar);
    if(vszcheck==1)
    {
      fprintf(outfile,"%c",vszchar);
    }
    else
    {
      vszcount=1000000;
    }
    vszcount++;
   } while(vszcount<10000);
  
  
  fclose(outfile);
  fclose(infile);
  printf("Vesuz file saved inside app directory as 'import_powers.vsz'\n");
  printf(" Use this file to load power-time data into Veusz\n\n");
}
void make_vsz_file2(void)
{
  int vszcount,vszcheck;
  char vszchar;
  sprintf(vszfilename,"%s/import_histograms.vsz\0",appdirname);
  sprintf(stylefilename,"%s/style_histograms.vsz\0",appdirname);
  printf("Making Veusz import file =\n   %s\n",vszfilename);
  printf(" using style from = %s\n\n",stylefilename);
  outfile=fopen(vszfilename,"wt");
  
  fprintf(outfile,"# This file can be used to load output from\n# WAVReader into Veusz\n");
  fprintf(outfile,"# Data from WAV file  %s\n\n",infilename);
  fprintf(outfile,"ImportFileCSV('%s', linked=True, dsprefix=u'hist_')\n\n",histfilename);
  fprintf(outfile,"ImportFileCSV('%s', linked=True, dsprefix=u'crest_')\n\n",crestfilename);
  infile=fopen(stylefilename,"rt");
  vszcount=0;
  do
  {
    vszcheck=(int)fscanf(infile,"%c",&vszchar);
    if(vszcheck==1)
    {
      fprintf(outfile,"%c",vszchar);
    }
    else
    {
      vszcount=1000000;
    }
    vszcount++;
   } while(vszcount<10000);
  
  
  fclose(outfile);
  fclose(infile);
  printf("Vesuz file saved inside app directory as 'import_histograms.vsz'\n");
  printf("Use this file to load histograms of levels into Veusz\n\n");
}

long read_header(void)
{
  long irh;

   printf("Reading header\n");
    
    get4(ChunkID);
    printf("ChunkID = %s\n",ChunkID);
    ChunkSize=get4int();
    printf("Chunk Size = %ld\n",ChunkSize);
    get4(Format);
    printf("Format = %s\n",Format);
    get4(Subchunk1ID);
    printf("Subchunk1ID = %s\n",Subchunk1ID);
    Subchunk1Size=get4int();
    AudioFormat=get2int();
    if((Subchunk1Size==16)&&(AudioFormat==1))
    {
      printf("LPCM format OK\n");
    }
    else
    {
      printf("Format unknown!\n");
    }
    NumChannels=get2int();
    printf("Number of Channels = %ld\n",NumChannels);
    SampleRate=get4int();
    printf("Sample Rate = %ld\n",SampleRate);
    ByteRate=get4int();
    printf("Byte Rate = %ld\n",ByteRate);
    BlockAlign=get2int();
    printf("Block Align = %ld\n",BlockAlign);
    BitsPerSample=get2int();
    printf("Bits per sample = %ld\n",BitsPerSample);
    BytesPerSample=BitsPerSample/8;
    
    printf("Bytes per sample = %ld\n",BytesPerSample);
    
    get4(Subchunk2ID);
    printf("Subchunk2ID = %s\n",Subchunk2ID);
    Subchunk2Size=(unsigned long)get4int();
    printf("Subchunk2Size = %lu [Number of Data payload bytes]\n",Subchunk2Size);
    
  irh=ByteRate;
  return irh;
}

long get3int(void)
{
  long result;
  unsigned char cip1,cip2,cip3;
  
  fscanf(infile,"%c",&cip1);
  fscanf(infile,"%c",&cip2);
  fscanf(infile,"%c",&cip3);
  result=(long)cip3;
  result=(long)cip2+256*result;
  result=(long)cip1+256*result;

  return result;
} 

long get2int(void)
{
  long result;
  unsigned char cip1,cip2;
  
  fscanf(infile,"%c",&cip1);
  fscanf(infile,"%c",&cip2);

  result=(long)cip2;
  result=(long)cip1+256*result;

  return result;
} 

long get4int(void)
{
  long result;
  unsigned char cip1,cip2,cip3,cip4;
  
  fscanf(infile,"%c",&cip1);
  fscanf(infile,"%c",&cip2);
  fscanf(infile,"%c",&cip3);
  fscanf(infile,"%c",&cip4);
    
  result=(long)cip4;
  result=(long)cip3+256*result;
  result=(long)cip2+256*result;
  result=(long)cip1+256*result;
  
  return result;
} 
void get4(char* outstring)
{
  long isp;
  char csp;
  isp=0;
  do
  {
    fscanf(infile,"%c",&csp);
    outstring[isp]=csp;
    isp++;
  } while (isp<4);
  outstring[4]=(char)0;

}









